/**
* @file  file_touch_keys.h
* @brief Schnittstelle fuer die Klasse FileTouchKeys.
*/
//////////////////////////////////////////////////////////////////////
#pragma once
#ifndef FILE_TOUCH_KEYS_H
#define FILE_TOUCH_KEYS_H

#ifdef _MSC_VER
#pragma warning(disable : 4996)
#endif

// Verwaltungsklasse fuer Datei
#include "file_intel_hex.h"

// Strukturdefinitionen
#include "interface/touch_keys_structs.h"

#include <array>

class FileTouchKeys : public FileIntelHex
{
public:
    FileTouchKeys();
    virtual ~FileTouchKeys();

public:
    enum { max_touch_keys = 100 };
    // Verwaltungsstrukturen fuer TouchKey
    TOUCHKEYNODE *m_pTouchKeysNode;
    std::array<TOUCHKEY *, max_touch_keys> m_pTouchKeys;

public:
    void resetData();
    bool load( const std::string &filePath );
    bool save( const std::string &filePath, bool appendToFile = false, bool appendEndLine = true );

    void init( unsigned char count, unsigned char deviceNumber );
    void SetTouchKey( int idx, const TOUCHKEY &tk );
    TOUCHKEY GetTouchKey( int idx );
    unsigned char GetTouchKeyCount()
    {
        return m_pTouchKeysNode->cnt;
    }

    unsigned char GetDeviceNumber()
    {
        return m_pTouchKeysNode->temp[0];
    }
};

#endif

